#!/bin/lua 
-- (c) 2005,2006 Robert Shingledecker
--

dofile("/etc/init.d/functions5.lua")

if #arg == 0 then
   print "Uso: nomefile"
   os.exit(1)
end

function extractInfo(s,sep1,sep2)
  local i = string.find(s,sep1,1,1)
  local j = string.find(s,sep2),1,1
  return string.sub(s,i+1,j-1)
end

function processLine(target)
   local line
   target = trim(target)
   if string.find(target,"[submenu]",1,1) then
      sep1 = "("
      sep2 = ")"
      label = extractInfo(target,sep1,sep2)
      line = '<Menu icon="folder.xpm" label="'..label..'">'
   end
   if string.find(target,"[exec]",1,1) then
      sep1 = "("
      sep2 = ")"
      label = extractInfo(target,sep1,sep2)
      sep1 = "{"
      sep2 = "}"
      action = extractInfo(target,sep1,sep2)
      line = '<Program icon="package.xpm" label="'..label..'"> '..action..' </Program>'
   end
   if string.find(target,"[end]",1,1) then
      line = "</Menu>"
   end
   return line
end

filename = arg[1]
local filein,err = io.open(filename,"r")
if not filein then
   print("Impossibile aprire il file "..filename..":"..err)
   os.exit(1)
else
   for line in filein:lines() do 
      print(processLine(line))
   end
   filein:close()
end
