function ansiclear()
   io.write("\027[2J")
end

function savecurspos()
   io.write("\027[s")
end

function restorecurpos()
   io.write("\027[u")
end

function cleareol()
   io.write("\027[K")
end

function gotoxy(x,y)
  io.write("\027[",x,";",y,"H")
end

function textcolor(foreg,backg)
  backg = 40 + backg
  foreg = 30 + foreg
  io.write(string.format("\027[0;1;%d;%dm",foreg,backg))
end

AnsiBlack   = 0
AnsiRed     = 1
AnsiGreen   = 2
AnsiYellow  = 3
AnsiBlue    = 4
AnsiMagenta = 5
AnsiCyan    = 6
AnsiWhite   = 7
AnsiGrey    = 8
AnsiNormal  = 9

function extractField(s,target,eod)
   if not eod  then 
      eod = "\n"
   end
   local i,j = string.find(s, target)
   if not i then
      return nil
   end
   k = string.gsub(string.sub(s,j+1)," ","")
   i,j = string.find(k,eod)
   return string.sub(k,1,i-1) 
end

function trim(s)
   local results 
   results,_ = string.gsub(s,"(%s+)(%s+)","")
   results,_ = string.gsub(results,"^%s","")
   results,_ = string.gsub(results,"%s$","")
   return results
end

function splitString(s,sep)
  _,count = string.gsub(s,sep,sep)
  local j = 1
  for c = 1, count do
    i,j = string.find(s,sep,j)
    j = j + 1
  end
  local h= string.sub(s,1,i-1)
  local t= string.sub(s,i+1)
  return h, t
end

function getOption(filename,option)
   local infodata,err = io.open(filename,"r")
   if not infodata then
      print("Non posso aprire il file " .. filename  .. ":" .. err)
      return nil
   end
   local infodatum = infodata:read("*a")
   infodata:close()
   return extractField(infodatum, option..":")
end

function headString(s,sep)
   _,count = string.gsub(s,sep,sep)
   j = 1
   for c = 1,count do
      i,j = string.find(s,sep,j)
      j = j + 1
   end   
   return(string.sub(s,1,i))
end 

function tailString(s,sep)
   _,count = string.gsub(s,sep,sep)
   j = 1
   for c = 1,count do
      i,j = string.find(s,sep,j)
      j = j + 1
   end   
   return(string.sub(s,i+1))
end 

function updateLine(filename,target,newline)
   local filein,err = io.open(filename, "r")
   if not filein then
      print("Non posso aprire il file ".. err)
      return nil
   end
   local data = filein:read("*a")
   datalen = #data
   filein:close()

   fileout = io.open(filename,"w")
   i = 1
   while i < datalen do
      j,k = string.find(data,"\n",i)
      line = string.sub(data,i,j-1)
      if string.find(line,target) then
         line = newline
      end
      fileout:write(line, "\n")
      i = j + 1
   end
   fileout:close()
   return 0
end

function capturing(cmd)
  local cmd_f = os.tmpname()
  local err_f = os.tmpname()
  os.execute(cmd .." > "..cmd_f.." 2>"..err_f)
  local f = io.open(err_f,"r")
  local err = f:read()
  f:close()
  os.remove(err_f)
  local data = {}
  local f = io.open(cmd_f,"r")
  for line in f:lines() do data[#data+1]=line end
  f:close()
  os.remove(cmd_f)
  return data, err
end

function getbootparam(target)
  io.input("/proc/cmdline")
  cmdline = io.read()
  io.input()

  local x,y=string.find(cmdline,target)
  if x ~= nil then
     result = string.sub(cmdline,y+1)
     local i,j=string.find(result,' ')
     if i ~= nil then
        result = string.sub(result,1,i-1)
     end
     if string.sub(target,-1,-1) ~= "=" then
        result = target
     end
     return result
  end
end

function isDir(target)
   local results = {}
   pipe = io.popen("ls -dp "..target.."/ 2>/dev/null |grep /$",'r')
   for line in pipe:lines() do
      results[#results+1] = line
   end
   if #results == 1 then
      return true
   else
      return false
   end
end

function readDir(target)
   local results = {}
   pipe = io.popen("ls -1 "..target.."/",'r')
   for line in pipe:lines() do
      results[#results+1] = line
   end
   return results
end

function getDirs(target)
   local results = {}
   pipe = io.popen("ls -F "..target.."/|fgrep /",'r')
   for line in pipe:lines() do
      results[#results+1] = line
   end
   return results
end
