#!/bin/lua
-- Mount script common for Damn Small Linux
-- By John Andrews
-- ported to murgaLua 10-22-06
-- Added update_mountables() for dynamic list by RS 11-12-06
-- Dropped execute grep from test_if_mounted() by RS 11-17-06
-- Changed to mount_name to handle /mnt/auto/cdrom & floppy by RS 02-21-07

function update_mountables()
  nl = 1
  mount_locations = {}
  mount_name = {}
  io.input("/etc/fstab")
  for thisline in io.lines() do
    result = string.find(thisline,"/mnt/%ad%a%d+")
    if result == nil then
      result = string.find(thisline,"/mnt/auto/%a+")
    end
    if result ~= nil then 
      device = string.match(thisline,"^/dev/%w+")
      if device ~= nil then
        mount_locations[nl] = device
        local g =string.gsub(mount_locations[nl],".+\/","")
        if string.find(g,"cdrom") then g = "auto/"..g end
        if string.find(g,"fd0") then g = "auto/floppy" end
        g = "/mnt/"..g
        mount_name[nl] = g
--      print(g)
        nl = nl + 1
      end
    end
  end
end

function test_if_mounted() 
  mtab=io.input("/etc/mtab")
  mtablines = io.read("*a")
  io.close(mtab)
  is_mounted=string.match(mtablines,mount_name[n].." ")
  if is_mounted ~= nil then 	
    mount_or_un = "mounted"
    m_color = 10
    if string.find(is_mounted,"^/cdrom") then
      m_color = 12
      mount_or_un = "irregular"
    end
  else
    mount_or_un = "unmounted"
    m_color = 9
  end
  is_mounted = nil
  mount_me:color(m_color)
  mount_me:label(mount_or_un)
  mount_me:redraw()
end

function mount_it()
  os.execute("rm -rf /tmp/.merror")
  local action
  if mount_or_un == "mounted" then
    action = "sudo umount " .. mount_name[n] .. " 2>/tmp/.merror"
  elseif mount_or_un == "irregular" then
    action = "echo \"Questa partizione  gi montata come /cdrom/\" >/tmp/.merror"
  else
    action = "sudo mount "
    if string.find(mount_name[n],"floppy") then action = action .. "/dev/fd0 " end
    action = action .. mount_name[n] .. " 2>/tmp/.merror"
  end
-- print(action)
  os.execute(action)
  file2 = io.input("/tmp/.merror")
  local r = io.read("*a")
  io.close(file2)
  string.gsub(r, "([^\n]+)", function (l)
    m_error = l
  end)
  if m_error then
    fltk.fl_alert("Errore: "..m_error)
  end
  m_error = nil
end

function mountings()
  test_if_mounted()
  mount_it()
  test_if_mounted()
end
