#!/bin/lua
-- (c) 2005,2006 Robert Shingledecker
-- iconsnap a layout manager for xtdesk uses xtdeskrc for size.
require("fltk")

dofile("/etc/init.d/functions5.lua")

function processInfo(filename)
   local iconitem,err = io.open(filename,"r")
   if not iconitem then
      print("Impossibile aprire il file " .. filename .. ":" .. err)
      return nil
   end
   local icondata = {}
   for line in iconitem:lines() do icondata[#icondata + 1] = line end
   iconitem:close()

   local newiconfile,err = io.open(filename,"w")
   if not newiconfile then
      print("Impossibile aprire il file " .. filename .. ":" .. err)
      return nil
   end
   for i = 1, #icondata do
      infoLine = icondata[i] 
      if string.find(infoLine,"X:")~= nil then
         xpos = tostring(width*(colcnt - 1) + 8)
         infoLine,_ = string.gsub(infoLine,"(%d+)",xpos,1)
      end
      if string.find(infoLine,"Y:")~= nil then
         ypos = tostring(height*(rowcnt - 1) + top)
         infoLine,_ = string.gsub(infoLine,"(%d+)",ypos)
      end
      newiconfile:write(infoLine,"\n")
   end
   newiconfile:close()
   return
end

-- Main

cols = tonumber(getOption(".xtdesktop/xtdeskrc", "Cols"))
if cols == 0 then exit(0) end

width = tonumber(getOption(".xtdesktop/xtdeskrc", "Width"))
height = tonumber(getOption(".xtdesktop/xtdeskrc", "Height"))
top = tonumber(getOption(".xtdesktop/xtdeskrc", "TopMargin"))

listname = os.tmpname()
if os.execute('ls -1 .xtdesktop/*.lnk|grep -v "^.xtdesktop/plugin_" > ' .. listname) ~= 0 then
   print("No Icons Found.")
   os.exit(1)
end
local iconlist,err = io.open(listname,"r")
if not iconlist then
   print("Impossibile aprire il file " .. listname .. ":" .. err)
   os.exit(1)
end
local iconname = iconlist:read("*l")
colcnt = 1
rowcnt = 1
while iconname do
   processInfo(iconname)
   if colcnt == cols then
      colcnt = 1
      rowcnt = rowcnt + 1
   else
      colcnt = colcnt + 1
   end
   iconname = iconlist:read("*l")
end
iconlist:close()
os.remove(listname)
