#!/bin/lua
-- (c) 2005,2006 Robert Shingledecker <robert@damnsmalllinux.org> 
-- GUI frontend to the date and hwclock commands

require("fltk")
w = fltk:Fl_Window(200,200, "Strumento x la data e l'ora")

year_input = fltk:Fl_Input(60,10,50,25,"Anno:")
year_input:value(os.date("%Y"))
year_down = fltk:Fl_Button(120,10,25,25)
year_down:label("@<")
year_down:callback(
function(year_down)
   year_input:value(year_input:value() - 1)
end)

year_up = fltk:Fl_Button(150,10,25,25)
year_up:label("@>")
year_up:callback(
function(year_up)
   year_input:value(year_input:value() + 1)
end)

month_input = fltk:Fl_Input(60,40,50,25,"Mese:")
month_input:value(os.date("%m"))
month_down = fltk:Fl_Button(120,40,25,25)
month_down:label("@<")
month_down:callback(
function(month_down)
   month_num = tonumber(month_input:value()) - 1
   if month_num < 1 then month_num = 12 end
   month_input:value(string.format("%02u",month_num))
end)
month_up = fltk:Fl_Button(150,40,25,25)
month_up:label("@>")
month_up:callback(
function(month_up)
   month_num = tonumber(month_input:value()) + 1
   if month_num > 12 then month_num = 1 end
   month_input:value(string.format("%02u",month_num))
end)

day_input = fltk:Fl_Input(60,70,50,25,"Giorno:")
day_input:value(os.date("%d"))
day_down = fltk:Fl_Button(120,70,25,25)
day_down:label("@<")
day_down:callback(
function(day_down)
   day_num = tonumber(day_input:value()) - 1
   if day_num < 1 then day_num = 31 end
   day_input:value(string.format("%02u",day_num))
end)
day_up = fltk:Fl_Button(150,70,25,25)
day_up:label("@>")
day_up:callback(
function(day_up)
   day_num = tonumber(day_input:value()) + 1
   if day_num > 31 then day_num = 1 end
   day_input:value(string.format("%02u",day_num))
end)

hour_input = fltk:Fl_Input(60,100,50,25,"Ora:")
hour_input:value(os.date("%H"))
hour_down = fltk:Fl_Button(120,100,25,25)
hour_down:label("@<")
hour_down:callback(
function(hour_down)
   hour_num = tonumber(hour_input:value()) - 1
   if hour_num < 0 then hour_num = 23 end
   hour_input:value(string.format("%02u",hour_num))
end)
hour_up = fltk:Fl_Button(150,100,25,25)
hour_up:label("@>")
hour_up:callback(
function(hour_up)
   hour_num = tonumber(hour_input:value()) + 1
   if hour_num > 23 then hour_num = 0 end
   hour_input:value(string.format("%02u",hour_num))
end)

min_input = fltk:Fl_Input(60,130,50,25,"Min:")
min_input:value(os.date("%M"))
min_down = fltk:Fl_Button(120,130,25,25)
min_down:label("@<")
min_down:callback(
function(min_down)
   min_num = tonumber(min_input:value()) - 1
   if min_num < 0 then min_num = 59 end
   min_input:value(string.format("%02u",min_num))
end)
min_up = fltk:Fl_Button(150,130,25,25)
min_up:label("@>")
min_up:callback(
function(min_up)
   min_num = tonumber(min_input:value()) + 1
   if min_num > 59 then min_num = 0 end
   min_input:value(string.format("%02u",min_num))
end)

ok = fltk:Fl_Button(60,160,70,25,"&OK")
ok:callback(
function(ok)
  os.execute("sudo date "..month_input:value()..day_input:value()..hour_input:value()..min_input:value()..year_input:value()) 
  os.execute("sudo hwclock --systohc")
  fltk.fl_alert("Riavvia il manager d finestre: men principale ->Esci->Riavvia gestore di finestre")
  os.exit(0)
end)

w:show()
Fl:run()
