#!/bin/bash
# Check for various device setup to save settings
# Called from exit.lua
# (c) Robert Shingledecker 2006-2007
. /etc/init.d/dsl-functions


CMDLINE="$(cat /proc/cmdline)"
MYDSLDIR="$(realpath `cat /opt/.mydsl_dir`)"
ACTION="$1"
CHK_BACKUP="$2"

if [ "$CHK_BACKUP" == "yes" ] && [ ! -s /opt/.backup_device ]; then
   popup.lua 'Attenzione! Hai richiesto il salvataggio
x nessuna periferica d backup  stata scelta!
X favore usa il pannello d controllo e clicca su salva/ ripristina.
Spegnimento abortito!'
   exit 1
fi      

if [ -e /KNOPPIX/bin/ash ]; then
  if [ -e /tmp/printer.flag ]; then
    if [ -z "$(grep apsfilter /opt/.filetool.lst)" ]; then
      ANS=`popask.lua 'Noto che hai configurato una stampante. Questa funziona? Salvo la configurazione?'`
      if [ "$ANS" == 1 ]; then
         sed -i '$s~$~\nopt/printcap\nopt/apsfilter/\nvar/spool/lpd/~' /opt/.filetool.lst
         sed -i '$s~$~\n/usr/sbin/lpd~' /opt/bootlocal.sh
         CHK_BACKUP="yes"
      fi
    fi
  fi
fi

/usr/local/bin/umix -sf "$HOME"/.umix

if [ -s /opt/.backup_device ]; then 
filetool.sh backup noprompt
if [ "$?" != 0 ]; then
   popup.lua 'Fatale! Backup fallito.
X favore correggilo.
Forse non hai spazio libero o hai delle
righe vuote in /opt/.filetool.lst
o sempre nel solito files c sono riferimenti
a file o cartelle inesistenti. 
Spegnimento abortito!'
   exit 1
fi      
fi

# remove MyDSL shortcuts/icons

for F in `ls -1 /tmp/mydsl.installed`; do
 for S in `cat /tmp/mydsl.installed/$F`; do
   sudo rm "$MYDSLDIR"/"$F" 2>/dev/null
 done
done
sudo rm -f "$MYDSLDIR"/*.app 2>/dev/null
sed -i '/mydsl.icons/d' /opt/.dfmext
/usr/bin/cleanIcons.lua

# remove MyDSL mounts
if [ -f /tmp/mydsl.map ]; then
   for LINE in `grep -v "^free" /tmp/mydsl.map`
   do
      sudo /etc/init.d/mountci "$LINE" shutdown
   done
fi
# finally remove the icon/shortcut list
sudo rm -rf /tmp/mydsl.installed/*
sudo rm -rf /tmp/mydsl.menu/*

case "$ACTION" in
  reboot )
    sudo shutdown -r now
  ;;
  shutdown )
    sudo shutdown -h now
  ;;
  * )
    sudo shutdown -h now
  ;;
esac
