#!/usr/bin/env lua
--[[
  MyDSL SQL Search Tool, SQL and other GUI mods by Robert Shingledecker
  Started from an early version of mikshaw's 2008 mydsl info parser.
]]--

require("fltk")
function updatedb(nofile)
   if not nofile then backup=os.rename(database,database..".bak") end
   os.execute("aterm  +tr -bg white -fg black -geometry 80x4 -title \"Aggiornamento database \" -e wget "..dburl.." -O "..database)
end

function doSQL()
 if inputSQL:value() ~= "" then
   results:clear()
   selected = {}
   field_names = {}
   stmt = db:prepare(inputSQL:value())
   if stmt == nil then
      fltk.fl_alert(db:errmsg())
   else
      field_names = stmt:get_names()
      for row in stmt:rows(inputSQL:value()) do
         results:add(row[1].."\t"..row[2])
         selected[#selected+1] = row
      end
      stmt:finalize()
      info_display:take_focus()
   end
 end
end

function showSQL()
   if results:value() > 0 then
      viewResults = ""
      for i = 1, #field_names do
         if field_names[i] == "comments" then
            selected[results:value()][i] = string.gsub(selected[results:value()][i],"%^","\n")
         end
         viewResults = viewResults .. field_names[i].."\t"
         viewResults = viewResults .. selected[results:value()][i].."\n"
      end
      info_display:value(viewResults)
      tabs:value(tab1)
      tab1:hide()
      tab3:show()
   end
end

function quit()
  db:close()
  os.exit(0)
end


ww=420; wh=360; bh=25
w=fltk:Fl_Window(ww,wh,"MyDSL SQL Strumento d ricerca")
w:callback(quit)

mb = fltk:Fl_Menu_Bar(0,0,ww,bh)
mb:add("&File/&UpdateDB",0,updatedb)
mb:add("&File/E&xit",0,quit)
mb:callback(menu_items)

tabs=fltk:Fl_Tabs(0,bh,ww,wh-bh)

tab1=fltk:Fl_Pack(1,bh+1,ww,0,"SQL")
inputSQL=fltk:Fl_Input(0,0,ww-10,bh)
inputSQL:when(fltk.FL_WHEN_ENTER_KEY_ALWAYS)
inputSQL:callback(doSQL)

results=fltk:Fl_Select_Browser(0,0,ww-10,wh-(8+bh*3))
results:textfont(fltk.FL_SCREEN)
results:textsize(12)
results:when(fltk.FL_WHEN_CHANGED)
results:callback(showSQL)
fltk:Fl_End()

--[[  *** not implemented yet *** 
tab2=fltk:Fl_Group(0,0,ww,wh-bh,"QBE")
field_label = {"loc","titolo","desc","ver","autore","sito","diritti","utente","corrente","commenti"}
field_len = {120,180,325,240,320,290,325,285,110,335}
field_in = {}
for i = 1, #field_label do
  field_in[i] = fltk:Fl_Input(75,28+(28*(i-1)),field_len[i],bh,field_label[i])
end
okBtn = fltk:Fl_Return_Button(340, 310, 70, 20, "OK");
okBtn:callback(
function(okBtn)
  for i = 1, #field_label do
    if field_in[i]:value() ~= "" then
      print(field_label[i] .." ".. field_in[i]:value())
    end
  end
end)
fltk:Fl_End()
]]--

tab3=fltk:Fl_Group(0,0,ww,wh-bh,"Info")
info_display=fltk:Fl_Multiline_Output(4,bh+4,ww-10,wh-(30+bh*2))
info_display:textfont(fltk.FL_SCREEN)
info_display:textsize(12)

install=fltk:Fl_Return_Button(340,310,70,20,"Istalla")
install:callback(
function()
 os.execute("mydsl-load "..selected[results:value()][2].." "..selected[results:value()][1])
end
)

w:resizable(tabs)
tabs:resizable(tab1)
tabs:resizable(tab2)
tab1:resizable(info_display)
-- tab2:resizable(results)
tab3:resizable(results)
w:show()

mydsldirfile=io.open("/opt/.mydsl_dir")
if not mydsldirfile then
 print("Impossibile aprire "..mydsldirfile)
 os.exit(1)
end
mydsl_dir=mydsldirfile:read("*l")
mydsldirfile:close()

database = mydsl_dir.."/mydsl.db"
dburl="ftp://ibiblio.org/pub/Linux/distributions/damnsmall/mydsl/mydsl.db"
databaseCheck = io.open(database)
if databaseCheck then
   databaseCheck:close()
else
   updatedb(1)
end

selected = {}
field_names = {}
db = sqlite3.open(database)
inputSQL:value("select * from mydsl order by loc, title;")
inputSQL:take_focus()

Fl:run()
