#!/bin/lua
-- (c) Robert Shingledecker 2005, 2006
-- GUI frontend to rdesktop
-- resolution, bit depth selection by Daniel Plata Lorenzo "MakodFilu"

require("fltk")
-- #define section (somewhat)
ww=280 -- Window width
wh=120 -- Window height
bw=90  -- Button width
bh=25  -- Button height

-- L10N section (somewhat)
canceltext="&Annulla"
connecttext="&Connetti"
servertext="Server:"
resolutiontext={"640x480";"800x600";"1024x768";"A tutto schermo"}
depthtext={"256 Colori";"65K Colori"}

-- code section (somewhat clean :)))
w = fltk:Fl_Window(ww,wh,"Rdesktop")
input = fltk:Fl_Input(60,15,210,bh,servertext)

selresolution = fltk:Fl_Slider(40,60,90,15,resolutiontext[2])
selresolution:align(fltk.FL_ALIGN_TOP)
selresolution:type(5)
selresolution:range(1,4)
selresolution:step(1)
selresolution:value(2)

selresolution:callback(
function(selresolution)
    selresolution:label(resolutiontext[selresolution:value()])
    selresolution:redraw()
end)

seldepth = fltk:Fl_Slider(160,50,15,bh,depthtext[1])
seldepth:align(fltk.FL_ALIGN_RIGHT)
seldepth:type(0)
seldepth:range(1,2)
seldepth:step(1)
seldepth:value(1)

seldepth:callback(
function(seldepth)
  seldepth:label(depthtext[seldepth:value()])
  seldepth:redraw()
end)

cancel = fltk:Fl_Button(ww-2*bw*1.2,wh-35,bw,bh,canceltext)
cancel:callback(
function(cancel)
  os.exit(0)
end)

connect = fltk:Fl_Return_Button(ww-1*bw*1.2,wh-35,bw,bh,connecttext)
connect:callback(
function(connect)
  if input:value() == "" then
    io.write(string.char(7)) io.flush()
  else
    if selresolution:value() == 1 then resolution="-g 640x480 "
      elseif selresolution:value() == 2 then resolution="-g 800x600 "
      elseif selresolution:value() == 3 then resolution="-g 1024x768 "
      elseif selresolution:value() == 4 then resolution="-f "
    end
    if seldepth:value() == 1 then depth="-a 8 "
      else depth="-a 16 "
    end
    os.execute('/usr/bin/rdesktop '..resolution..depth..input:value()..' &')
    os.exit(0)
  end
end)

w:show()
Fl:run()
