#!/bin/lua
-- (c) 2007 Robert Shingledecker
--
dofile("/etc/init.d/functions5.lua")

DFMEXT = "/opt/.dfmext"
MYMENU  = "/tmp/mydsl.menu/"
MYICONS = "/tmp/mydsl.icons/"

function extractInfo(s,sep1,sep2)
  local i = string.find(s,sep1,1,1)
  local j = string.find(s,sep2),1,1
  return string.sub(s,i+1,j-1)
end

function updateDfmext(label,icon)
   local dfmextIn,err = io.open(DFMEXT,"r")
   if not dfmextIn then return end
   workfile = os.tmpname() 
   local dfmextOut,err = io.open(workfile,"w")
   if not dfmextOut then return end
   for line in dfmextIn:lines() do 
      dfmextOut:write(line,"\n")
      if string.find(line,"#Begin",1,1) then
         dfmextEntry = label..";"..icon..";!0!"
         dfmextOut:write(dfmextEntry,"\n")
      end
   end
dfmextIn:close()
dfmextOut:close()
os.execute("mv "..workfile.." "..DFMEXT)
end

if #arg ~= 2 then
   print("Uso: shortcuts.lua voce_d_men MyDSL_nome_cartella")
   os.exit(1)
end
if arg[1] == "optional" then os.exit(0) end

extnname = arg[1]
filename = MYMENU .. extnname
MYDSL_DIR = arg[2]

genericIcon = true
iconName = arg[1] .. ".xpm"
local myicon,err = io.open(MYICONS .. iconName,"r")
if not myicon then
   ICON = "package.xpm"
else
   ICON = MYICONS .. iconName
   genericIcon = false
   myicon:close()
end

local myinstalled,err = io.open("/tmp/mydsl.installed/"..extnname,"a")
if not myinstalled then
   print("Cannot open /tmp/mydsl.installed/"..extnname.." "..err)
   os.exit(1)
end

for item in io.lines(filename) do
   item = trim(item)
   if string.find(item,"[exec]",1,1) then
      sep1 = "("
      sep2 = ")"
      label = extractInfo(item,sep1,sep2)
      label = string.gsub(trim(label),"[ /,.-]","_")
      sep1 = "{"
      sep2 = "}"
      command = extractInfo(item,sep1,sep2)
      if genericIcon then 
         label = label..".app" 
      else
         updateDfmext(label,ICON)
      end
      io.output(MYDSL_DIR.."/"..label)
      io.write(command)
      io.flush()
      io.output()
      os.execute("chmod +x "..MYDSL_DIR.."/"..label)
      myinstalled:write(label,"\n")
   end
end
myinstalled:close()
