#!/bin/lua

-- (c) 2005,2006 Robert Shingledecker
-- System Stats 

require("fltk")
io.input("/usr/share/doc/dsl/release.txt")
release = io.read("*line")
io.input()
io.output("/tmp/stats.txt")
io.write("\t"..release.." "..os.date().."\n")
io.flush()
io.output()
os.remove("stats.txt")

window_width = 600
window_height = 350
view_port = window_height-25

-- Fl_fltk:Fl_Browser.initializers = {textfont=Font.courier}

w = fltk:Fl_Window(window_width,window_height,"DSL Statistiche d sistema")
w:callback(
function(w)
   os.remove("/tmp/stats.txt")
   os.exit(0)
end)   
tabs = fltk:Fl_Tabs(0,0,window_width,window_height)
tabs:box(fltk.FL_THIN_UP_BOX)
tabs:selection_color(fltk.FL_GREEN)

tab1 = fltk:Fl_Group(0,0,window_width,view_port,"cpu")
pg1browser = fltk:Fl_Browser(0,0,window_width,view_port)
pg1browser:textfont(fltk.FL_SCREEN)
os.execute('cat /proc/cpuinfo >> /tmp/stats.txt')
os.execute('cat /tmp/stats.txt >> stats.txt')
if not pg1browser:load("/tmp/stats.txt") then
   print("impossibile caricare browser.data")
   os.exit(1)
end
pg1browser:position(0)
fltk:Fl_End()

tab2 = fltk:Fl_Group(0,0,window_width,view_port,"mem")
pg2browser = fltk:Fl_Browser(0,0,window_width,view_port)
pg2browser:textfont(fltk.FL_SCREEN)
os.execute('cat /proc/meminfo | tee /tmp/stats.txt >> stats.txt')
if not pg2browser:load("/tmp/stats.txt") then
   print("impossibile caricare browser.data")
   os.exit(1)
end
fltk:Fl_End()

tab3 = fltk:Fl_Group(0,0,window_width,view_port,"rete")
pg3browser = fltk:Fl_Browser(0,0,window_width,view_port)
pg3browser:textfont(fltk.FL_SCREEN)
os.execute('cat /etc/sysconfig/netcard > /tmp/stats.txt')
os.execute('cat /etc/resolv.conf >> /tmp/stats.txt')
os.execute('ifconfig >> /tmp/stats.txt')
os.execute('cat /tmp/stats.txt >> stats.txt')
if not pg3browser:load("/tmp/stats.txt") then
   print("impossibile caricare browser.data")
   os.exit(1)
end
pg3browser:position(0)
fltk:Fl_End()

tab4 = fltk:Fl_Group(0,0,window_width,view_port,"moduli")
pg4browser = fltk:Fl_Browser(0,0,window_width,view_port)
pg4browser:textfont(fltk.FL_SCREEN)
os.execute('cat /proc/modules | tee /tmp/stats.txt >> stats.txt')
if not pg4browser:load("/tmp/stats.txt") then
   print("impossibile caricare browser.data")
   os.exit(1)
end
pg4browser:position(0)
fltk:Fl_End()

tab5 = fltk:Fl_Group(0,0,window_width,view_port,"pci")
pg5browser = fltk:Fl_Browser(0,0,window_width,view_port)
pg5browser:textfont(fltk.FL_SCREEN)
os.execute('lspci | tee /tmp/stats.txt  >> stats.txt')
if not pg5browser:load("/tmp/stats.txt") then
   print("impossibile caricare browser.data")
   os.exit(1)
end
pg5browser:position(0)
fltk:Fl_End()

tab6 = fltk:Fl_Group(0,0,window_width,view_port,"processi")
pg6browser = fltk:Fl_Browser(0,0,window_width,view_port)
pg6browser:textfont(fltk.FL_SCREEN)
os.execute('busybox ps | tee /tmp/stats.txt >> stats.txt')
if not pg6browser:load("/tmp/stats.txt") then
   print("impossibile caricare browser.data")
   os.exit(1)
end
pg6browser:position(0)
fltk:Fl_End()

tab7 = fltk:Fl_Group(0,0,window_width,view_port,"dmesg")
pg7browser = fltk:Fl_Browser(0,0,window_width,view_port)
pg7browser:textfont(fltk.FL_SCREEN)
os.execute('dmesg  | tee /tmp/stats.txt >> stats.txt')
if not pg7browser:load("/tmp/stats.txt") then
   print("impossibile caricare browser.data")
   os.exit(1)
end
pg7browser:position(0)
fltk:Fl_End()

tab8 = fltk:Fl_Group(0,0,window_width,view_port,"montaggi")
pg8browser = fltk:Fl_Browser(0,0,window_width,view_port)
pg8browser:textfont(fltk.FL_SCREEN)
os.execute('mount | tee /tmp/stats.txt  >> stats.txt')
if not pg8browser:load("/tmp/stats.txt") then
   print("impossibile caricare browser.data")
   os.exit(1)
end
pg8browser:position(0)
fltk:Fl_End()

tab9 = fltk:Fl_Group(0,0,window_width,view_port,"filesystems")
pg9browser = fltk:Fl_Browser(0,0,window_width,view_port)
pg9browser:textfont(fltk.FL_SCREEN)
os.execute('df -h | tee /tmp/stats.txt >> stats.txt')
if not pg9browser:load("/tmp/stats.txt") then
   print("impossibile caricare browser.data")
   os.exit(1)
end
pg9browser:position(0)
fltk:Fl_End()

tab10 = fltk:Fl_Group(0,0,window_width,view_port,"hardware")
pg10browser = fltk:Fl_Browser(0,0,window_width,view_port)
pg10browser:textfont(fltk.FL_SCREEN)
os.execute('cat /etc/sysconfig/knoppix | tee /tmp/stats.txt >> stats.txt')
if not pg10browser:load("/tmp/stats.txt") then
   print("impossibile caricare browser.data")
   os.exit(1)
end
pg10browser:position(0)
fltk:Fl_End()

tab11 = fltk:Fl_Group(0,0,window_width,view_port,"avvio")
pg11browser = fltk:Fl_Browser(0,0,window_width,view_port)
pg11browser:textfont(fltk.FL_SCREEN)
os.execute("sed 's/ /\\n/g' /proc/cmdline | tee /tmp/stats.txt >> stats.txt")
if not pg11browser:load("/tmp/stats.txt") then
   print("impossibile caricare browser.data")
   os.exit(1)
end
pg11browser:position(0)
fltk:Fl_End()

w:resizable(w)
w:show()
Fl:run()
