#!/bin/lua
-- (c) 2007 Robert Shingledecker
-- GUI front end to select Window Manager & Icons
require("fltk")
dofile("/etc/init.d/functions5.lua")

w = fltk:Fl_Double_Window(205, 175, "DSL opzioni del gestore d finestre")
w:callback(
function(w)
  os.exit(0)
end)

wmGroup = fltk:Fl_Group(10, 15, 185, 75)

jwmBtn = fltk:Fl_Round_Button(15, 20, 185, 25, "JWM: Joe's Window Mgr")
jwmBtn:type(fltk.FL_RADIO_BUTTON)
jwmBtn:value(1)
jwmBtn:callback(
function(jwmBtn)
  iconsBtn:value(1)
  iconsBtn:show()
end)

fluxboxBtn = fltk:Fl_Round_Button(15, 50, 185, 25, "Fluxbox Window Mgr")
fluxboxBtn:type(fltk.FL_RADIO_BUTTON)
fluxboxBtn:value(0)
fluxboxBtn:callback(
function(fluxboxBtn)
  iconsBtn:value(1)
  iconsBtn:show()
end)

fltk:Fl_End()  -- End of wm group

iconsBtn = fltk:Fl_Check_Button(70, 85, 80, 30, "Icone")
iconsBtn:tooltip("Non spuntare x non avere icone")
iconsBtn:type(fltk.FL_DOWN_BOX)
iconsBtn:value(1)
iconsBtn:callback(
function(iconsBtn)
  if iconsBtn:value() == 0 then 
    iconsBtn:value(1)
  else
    iconsBtn:value(0)
  end
end)

okBtn = fltk:Fl_Return_Button(25, 130, 60, 25, "OK")
okBtn:callback(
function(okBtn)
  if iconsBtn:value() == 1 then
     icons = "dfm"
  else
     icons = ""
  end
  if jwmBtn:value() == 1 then
     wm = "jwm"
  end
  if fluxboxBtn:value() == 1 then
     wm = "fluxbox"
  end
  home = os.getenv("HOME")
  file = home.."/.desktop"
  io.output(file)
  io.write("wm: "..wm.."\n")
  io.write("icons: "..icons.."\n")
  io.flush()
  io.output()

  os.execute("cp /opt/.mydsl_menu/"..wm.."/menu_template /opt/.mydsl_menu/"..wm.."/menu")
  for _,appname in ipairs(readDir("/tmp/mydsl.menu")) do
    os.execute("/usr/bin/desktop.sh "..appname)
  end

  os.execute("touch /tmp/xvesa")
  os.execute("killall Xvesa Xfbdev 2>/dev/null &")
  os.exit(0)
end)

cancelBtn = fltk:Fl_Button(115, 130, 60, 25, "Annulla")
cancelBtn:callback(
function(cancelBtn)
  os.exit(1)
end)

w:show()
Fl:run()
