#!/bin/lua
-- displays and umounts mounted .uci files
-- written by mikshaw, 2005
-- Changelog (yyyy/mm/dd)
--    2006/10/09: Updated to Lua 5.1.1/Fltk murgaLua by RS
--    2005/12/30: Changed UI to match DSL tools
--                Added hotkey support
--                Auto-selects first line for better keyboard support
--    2005/12/09: Displays total number of mounted UCIs
--    2005/12/08: First release

require("fltk")
function refresh(object)
  os.execute("awk '{print $1}' /etc/mtab | grep .uci$ >"..tempfile)
  file_list:load(tempfile)
--remove blank line at end (lua bug?)
  if file_list:text(file_list:size()) == "" then file_list:remove(file_list:size()) end
  os.remove(tempfile)
  uci_total:hide()
  uci_total:label("Files montati: "..file_list:size())
  uci_total:show()
  file_list:select(1)
end

ww = 400
wh = 150
tempfile = "/tmp/lsuci.tempfile"

w_main = fltk:Fl_Window(ww,wh,"DSL strumento x gli Uci")

file_list = fltk:Fl_Hold_Browser(2,2,ww-4,wh-30)

refreshBtn = fltk:Fl_Button(ww-123,wh-27,60,25,"&aggiorna")
refreshBtn:shortcut('r')
refreshBtn:callback(refresh)

umountBtn = fltk:Fl_Button(ww-62,wh-27,60,25,"&smonta")
umountBtn:shortcut('u')
umountBtn:callback(
function(umountBtn)
  if file_list:value() > 0 then 
    os.execute("mydsl-load "..file_list:text(file_list:value()))
    refresh()
  end
end)

uci_total = fltk:Fl_Box(2,wh-15,0,0)
uci_total:align(fltk.FL_ALIGN_RIGHT)

w_main.size_range(w_main,ww-50,wh-80)
w_main:resizable(w)
refresh()
w_main:show()
Fl:run()
