#!/bin/lua

-- (c) 2005,2006 Robert Shingledecker
-- background selector 

require("fltk")
dofile("/etc/init.d/functions5.lua")

-- Main

home = os.getenv("HOME")
windowMgr = getOption(home.."/.desktop","wm")

targetfile = home.."/."..windowMgr..".inc"
target = "xsri"

if #arg == 1 then
   command = "xsri --scale-width=100 --scale-height=100 "..arg[1]
   os.execute(command)
   updateLine(targetfile,target,command)
   os.exit(0)
end

sep = "/"
filetable = {}
listname = os.tmpname()
shortlistname = os.tmpname()

window_width = 300
window_height = 250

os.execute('ls -1 /opt/.backgrounds/*.{gif,jpg,png,tif,xpm} >'..listname)
-- os.execute('ls -1 .fluxbox/backgrounds/* >>'..listname)

local listitems,err = io.open(listname,"r")
if not listitems then
   print("Cannot open file "..listname..": "..err)
   os.exit(1)
end

local shortlistitems,err = io.open(shortlistname,"w")
if not shortlistitems then
   print("Cannot open file "..shortlistname..": "..err)
   os.exit(1)
end
local infoitem = listitems:read("*l")
while infoitem do
   table.insert(filetable,infoitem)
   basename = tailString(infoitem,sep)
   shortlistitems:write(basename.."\n")
   infoitem = listitems:read("*l")
end
listitems:close()
os.remove(listname)
shortlistitems:close()

w = fltk:Fl_Window(window_width,window_height,"DSL Seleziona Sfondo")
separator=fltk:Fl_Box(1,window_height-50,window_width-2,5)
separator:box(fltk.FL_UP_BOX)
separator:labeltype(fltk.FL_NO_LABEL)
w:callback(
function(w)
   os.remove(shortlistname)
   os.exit(0)
end)

selector = fltk:Fl_Hold_Browser(0,0,300,200)
selector:callback(
function(selector)
   selected_item = filetable[selector:value()]
end)

if not selector:load(shortlistname) then
   print("Ipossibile caricare ", shortlistname)
   os.exit(1)
end

scaleBtn = fltk:Fl_Round_Button(10, window_height-45,20,20,"Scala")
scaleBtn:type(fltk.FL_RADIO_BUTTON)
scaleBtn:selection_color(fltk.FL_RED)
scaleBtn:callback(
function(scaleBtn)
   imagePosition = "--scale-width=100 --scale-height=100 " 
end)   

emblemBtn = fltk:Fl_Round_Button(10, window_height-25,20,20,"Emblema")
emblemBtn:type(fltk.FL_RADIO_BUTTON)
emblemBtn:selection_color(fltk.FL_RED)
emblemBtn:callback(
function(emblemBtn)
   imagePosition = "--center-x --center-y --emblem " 
end)   

okBtn = fltk:Fl_Button(90,window_height-35,50,25,"Prova")
okBtn:callback(
function(okBtn)
   if selected_item == nil then
      fltk.fl_alert("Devi selezionare un'immagine!")
   else
      command = 'xsri '..imagePosition..selected_item
      os.execute(command)
   end
end)

installBtn = fltk:Fl_Button(140,window_height-35,50,25,"Istalla")
installBtn:callback(
function(installBtn)
   if command == nil then
      fltk.fl_alert("Devi selezionarte un'immagine e premere prova o scegliere un colore")
   else
      os.execute(command)
      updateLine(targetfile,target,command)
      os.remove(shortlistname)
      os.exit(0)
   end
end)

colorBtn = fltk:Fl_Button(190,window_height-35,50,25,"Color")
colorBtn:callback(
function(colorBtn)
   ok,r,g,b = fltk:fl_color_chooser(nil,41,81,121,"Seleziona colore")
   if ok == 1 then
      color_selected = string.format("%X%X%X",r,g,b)
      command = 'xsri --color=#'..color_selected
      os.execute(command)
   end
end)

helpBtn = fltk:Fl_Button(240,window_height-35,50,25,"Aiuto")
helpBtn:callback(
function(helpBtn)
   fltk.fl_message([[Visualizza le immagini dalla posizione standard::
   /opt/.backgrounds/

Usa prova x testare l'immagine selezionata. 
Usa Istalla x aggiornare il manager d finestre .inc file.]])
end)

selector:position(0)
scaleBtn:value(1)
imagePosition = "--scale-width=100 --scale-height=100 " 
command = nil
w:resizable(w)
w:show()
Fl:run()
