#!/bin/lua
-- (c) 2005,2006 Robert Shingledecker
-- GUI front end to Word viewer

require("fltk")
function data_check()
  if input:value() == "" then return nil end
  local file_check = io.open(input:value(),"r")
  if not file_check then return nil end
  return ""
end

function convertFile()
  convertWin = fltk:Fl_Window(140,50,"Converti")
  convertBox = fltk:Fl_Box(4,8,140,1)
  convertBox:label([[Pdf or Postscript?]])
  pdfBtn = fltk:Fl_Button(0,25,70,25,"P&df")
  pdfBtn:callback(
  function(pdfBtn)
    os.execute('/usr/bin/antiword -p letter \'' .. input:value() .. '\' > \''.. input:value() .. ".ps\'")
    os.execute('/usr/local/bin/ps2pdf \'' .. input:value() .. ".ps\'")
    os.remove(input:value() .. ".ps")
    os.exit(0)
  end)
  psBtn = fltk:Fl_Button(70,25,70,25,"&Ps")
  psBtn:callback(
  function(psBtn)
    os.execute('/usr/bin/antiword -p letter \'' .. input:value() .. '\' > \''.. input:value() .. ".ps\'")
    os.exit(0)
  end)
  convertWin:show()
end

if #arg == 1 then
   default = arg[1]
end

w = fltk:Fl_Window(320,75,"MSDoc Converte/Visualizza")
input = fltk:Fl_Input(60,10,210,25,"File:")
input:value(default)

selectBtn = fltk:Fl_Button(20,40,70,25,"&Seleziona")
selectBtn:callback(
function(selectBtn)
  doc_filename = fltk.fl_file_chooser("doc files","*.doc","")
  input:value(doc_filename)
end)

help = fltk:Fl_Button(90,40,70,25,"&Aiuto")
help:callback(
function(help)
  w = fltk:Fl_Window(300,85,"Aiuto")
  box = fltk:Fl_Box(3,3,298,83,[[ DSL visualizzatore e convertitore 
in formato postscript di documenti word.]])
  box:box(fltk.FL_THIN_UP_BOX) 
  box:labelfont(fltk.FL_HELVETICA_BOLD)
--  box:labelfont(1)
  w:show()
end)

convert = fltk:Fl_Button(160,40,70,25,"&Converti")
convert:callback(
function(convert)
  if data_check() then
    convertFile()
  else
    io.write(string.char(7)) io.flush()
  end
end)

view = fltk:Fl_Button(230,40,70,25,"&Visualizza")
view:callback(
function(view)
  if data_check() then
    workfile = os.tmpname()
    os.execute('/usr/bin/antiword -p letter \'' .. input:value() .. '\' > ' .. workfile)
    os.execute('/usr/local/bin/gvu -geometry 800x600 ' .. workfile) 
    os.remove(workfile)
    os.exit(0)
  else
    io.write(string.char(7)) io.flush()
  end
end)

w:show()
Fl:run()
