#!/bin/lua

-- (c) 2007 Robert Shingledecker
-- xtar.lua front end to view and process tar, tar.gz, and tgz files

require("fltk")
dofile("/etc/init.d/functions5.lua")

-- Main
home = os.getenv("HOME") .. "/"

if #arg == 1 then
   filename = arg[1]
else
   filename = fltk.fl_file_chooser("Xtar", "Types (*.{tar,tgz,tar.gz})",home)
   if filename == nil then
      os.exit(1)
   end
end
flags = "-ztf"
selected_item = ""

viewfile = os.tmpname()
view = io.open(viewfile,"w")
pipe = io.popen("tar "..flags.." "..filename)
line = pipe:read("*l")
while line do
  view:write(line.."\n")
  line = pipe:read("*l")
end
view:flush()
view:close()
pipe:close()

w = fltk:Fl_Window(250,327,"Xtar")
w:callback(
  function(w)
    os.remove(viewfile)
    os.exit(0)
  end
)

browser = fltk:Fl_Hold_Browser(0,0,250,227)
browser:callback(
function(browser)
   selected_item = browser:text(browser:value())
   print(selected_item)
end)

if not browser:load(viewfile) then
   print("impossibile aprire ", "info.lst")
   os.exit(1)
end

installGroup = fltk:Fl_Group(10, 228, 185, 50)

extBtn = fltk:Fl_Round_Button(5, 235, 185, 25, "Estrai in:")
extBtn:type(fltk.FL_RADIO_BUTTON)
extBtn:value(1)
extBtn:callback(
function(extBtn)
  pathInput:value(home)
  pathInput:show()
end)

mydslBtn = fltk:Fl_Round_Button(5, 260, 185, 25, "Processa come MyDSL")
mydslBtn:type(fltk.FL_RADIO_BUTTON)
mydslBtn:value(0)
mydslBtn:callback(
function(mydslBtn)
  pathInput:value("")
  pathInput:hide()
end)

fltk:Fl_End()  -- End of install group

pathInput = fltk:Fl_Input(90, 235, 150, 25)
pathInput:tooltip("Inserisci il percorso")
pathInput:value(home)

okBtn = fltk:Fl_Return_Button(40, 290, 60, 25, "OK")
okBtn:callback(
function(okBtn)
  if mydslBtn:value() == 1 then
     os.execute("mydsl-load ".. filename)
  end
  if extBtn:value() == 1 then
     flags = "-zxf"
     os.execute("tar -C "..pathInput:value().." "..flags.." "..filename.." "..selected_item)
  end
  os.exit(0)
end)

cancelBtn = fltk:Fl_Button(120, 290, 60, 25, "Annulla")
cancelBtn:callback(
function(cancelBtn)
  os.exit(1)
end)

browser:position(0)
w:resizable(w)
w:show()
Fl:run()
