#!/bin/lua

-- (C) Robert Shingledecker 2005,2006
--
-- Main GUI loop for myDSL Extensions

require("fltk")
dofile("/etc/init.d/functions5.lua")

function b1(self)
   os.execute("/usr/sbin/filetool.lua")
end

function b2(self)
   os.execute("sudo /usr/local/bin/netcardconf.lua")
end

function b3(self)
   os.execute("/usr/local/bin/wallpaper.lua")
end

function b4(self)
  if self:box() == fltk.FL_DOWN_BOX then
     os.execute("sudo killall -9 lpd")
     self:box(fltk.FL_UP_BOX)
  else
     os.execute("sudo /usr/sbin/lpd")
     self:box(fltk.FL_DOWN_BOX)
  end
  self:redraw()
end

function b5(self)
   os.execute("aterm +tr -T apsfilter -e sudo /usr/share/apsfilter/SETUP")
   os.execute("touch /tmp/printer.flag")
end

function b6(self)
   os.execute("aterm +tr -T wlcardconfig -e sudo /usr/sbin/wlcardconfig")
end

function b7(self)
   os.execute("aterm +tr -T kbdconfig -e sudo /usr/sbin/kbdconfig")
   fltk.fl_message("Devi riavviare X windows affinch le modifiche alla tastiera abbiano effetto.")
end

function b8(self)
  if self:box() == fltk.FL_DOWN_BOX then
     os.execute("sudo killall -9 betaftpd")
     self:box(fltk.FL_UP_BOX)
  else
     os.execute("sudo /usr/sbin/betaftpd")
     self:box(fltk.FL_DOWN_BOX)
  end
  self:redraw()
end

function b9(self)
   os.execute("datetool.lua")
end

function b10(self)
   os.execute("ndissetup")
end

function b11(self)
   os.execute("cardcontrol.lua")
end

function b12(self)
  if self:box() == fltk.FL_DOWN_BOX then
     os.execute("sudo /opt/monkey/bin/banana stop")
     self:box(fltk.FL_UP_BOX)
  else
     os.execute("sudo /opt/monkey/bin/banana start")
     self:box(fltk.FL_DOWN_BOX)
  end
  self:redraw()
end

function b13(self)
   os.execute("sudo /usr/sbin/pppdial")
end

function b14(self)
   os.execute("iwconfig_setup")
end

function b15(self)
   os.execute("fdtool.lua")
end

function b16(self)
  if self:box() == fltk.FL_DOWN_BOX then
     os.execute("sudo /etc/init.d/ssh stop")
     self:box(fltk.FL_UP_BOX)
  else
     os.execute("sudo /etc/init.d/ssh start")
     self:box(fltk.FL_DOWN_BOX)
  end
  self:redraw()
end

function b17(self)
  os.execute("aterm +tr -T PPPoEconf -e sudo /usr/sbin/pppoeconf")
end

function b18(self)
   os.execute("prism2_setup")
end

function b19(self)
   os.execute("dslMirror.lua")
end

function b20(self)
  if self:box() == fltk.FL_DOWN_BOX then
     os.execute("sudo /sbin/pump -k")
     self:box(fltk.FL_UP_BOX)
  else
     os.execute("sudo /sbin/pump -i eth0")
     self:box(fltk.FL_DOWN_BOX)
  end
  self:redraw()
end

function b21(self)
   os.execute("dillo file:/usr/share/doc/dsl/getting_started.html")
end

function b22(self)
   os.execute("xvesa.lua")
end

function b23(self)
   os.execute("stats.lua")
end

function b24(self)
  if self:box() == fltk.FL_DOWN_BOX then
     os.execute("sudo pkill MyCron")
     self:box(fltk.FL_UP_BOX)
  else
     os.execute("sudo MyCron &")
     self:box(fltk.FL_DOWN_BOX)
  end
  self:redraw()
end

btnCB = {b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13,b14,b15,b16,b17,b18,b19,b20,b21,b22,b23,b24}

w = fltk:Fl_Window(570,255, "DSL Control Panel")
btn={}
btnLabel={"Salva/Carica","Config rete","Sfondi"       ,"Stampa/Lpd"   ,"Config stampa","Config wifi","Tastiera","BetaFTP","Data/Ora","Ndiswrapper","Strum PCMCIA","Monkey Web","Dialup","Iwconfig","Strum Floppy","SSH server","PPPOE","Prism2","Selez Mirror","DHCP client","Aiuto","Xvesa","Statist d sist","Cron"}
btnWidth=130; btnHeight=30
rows=6; cols=4; spacer=10

for h=1, rows do
  for w = 1, cols do
    i = cols*(h-1)+w
       btn[i] = fltk:Fl_Button(btnWidth*(w-1)+spacer*w,btnHeight*(h-1)+spacer*h,btnWidth,btnHeight,btnLabel[i])
       btn[i]:callback(btnCB[i])
    end
end

local data = ""
for line in (io.popen("busybox ps")):lines() do
   data = data .. line
end

if string.find(data,"lpd") then
   btn[4]:box(fltk.FL_DOWN_BOX)
end

if string.find(data,"betaftpd") then
   btn[8]:box(fltk.FL_DOWN_BOX)
end

if string.find(data,"monkey") then
   btn[12]:box(fltk.FL_DOWN_BOX)
end

if string.find(data,"sshd") then
   btn[16]:box(fltk.FL_DOWN_BOX)
end

if string.find(data,"pump") then
   btn[20]:box(fltk.FL_DOWN_BOX)
end

if string.find(data,"MyCron") then
   btn[24]:box(fltk.FL_DOWN_BOX)
end

w:show()
Fl:run()
