#!/bin/bash
#(c) 2005 Robert Shingledecker
#Frugal Grub Install

. /etc/init.d/dsl-functions

if [ $UID != 0 ]; then
  echo "Sei root?"
  echo -n "Premi il tasto invio. "; read gagme
  exit 1
fi    

if [ ! -d /boot/grub ]; then
  echo "Devi avere grub.dsl."
  echo -n "Premi il tasto invio. "; read gagme
  exit 1
fi    

MIRROR=$(dslrc.lua Mirror) || MIRROR="ibiblio.org/pub/Linux/distributions/damnsmall/"
PROTOCOL=$(dslrc.lua Protocol) || PROTOCOL="http"

echo
echo "${RED}DSL ${WHITE}Immagine compressa ${BLUE}Istalla/Aggiorna.${NORMAL}"
echo "${YELLOW}Nessuna responsabilit x perdita dati o danneggiamento hardware!${NORMAL}"
echo " "
echo "Una partizione linux larga abbastanza (60MB) dove copiare l'immagine"
echo "deve essere creata prima dell'istallazione."
echo " "
echo "Una seconda partizione opzionale (ext2 or vfat)"
echo "dove mettere le estensioni MyDSL deve essere creata prima dell'istallazione."
echo
echo -n "${CYAN}Inserisci la partizone dove copiare l'immagine ${WHITE}(EXAMPLE: ${YELLOW}hda2): ${NORMAL}" 
read TARGET
if [ -z "$TARGET" ] ; then
  echo "Nessuna partizione scelta. Il programma sar terminato."
  echo -n "Premi il tasto invio. "; read gagme
  exit 1
fi    

DISK="$(echo $TARGET | tr -d [0-9])"
FDISK="$(sfdisk -l /dev/$DISK|grep $TARGET|awk '{print $(NF-1)}'|head -n1)"
if [ "$FDISK" != "83" ]; then
  echo "${RED}Scusa, il sistema non ha individuato una partizione d tipo linux.${NORMAL}"
  echo "Forse devi solo riavviare il PC, os il sistema pu rileggere"
  echo "la tabella delle partizioni, o crea la(e) tua(e) partizione(i) ${YELLOW}cfdisk"
  echo "${NORMAL}e poi riavvia il computer."
  echo "Il programma sta terminando..."
  echo -n "Premi il tasto invio. "; read gagme
  exit 1
fi

if [ ! -e /mnt/$TARGET ]; then
  mkdir /mnt/$TARGET
fi  

echo "Istalla da:"
echo "  [L]iveCD o istallazione frugale"
echo "  [P]endrive"
echo "  Local [I]so File"
echo "  Sarica l'ultima ISO dal [W]eb"
echo "  Da Poormans via [B]ootfloppy"
echo -n "Scegli (l/p/i/w/b): "
read INSTALL
case "$INSTALL" in 
  "L" | "l")
    if [ -f /etc/sysconfig/toram ]; then
       echo "Stai eseguendo 'toram' mode, not a liveCD!"
       echo -n "Il programma sta terminando... Premi il tasto invio. "; read gagme
       exit 1
    fi
    SOURCE="/cdrom"
    IMAGE="/cdrom"
    BOOT="/cdrom/boot/isolinux"
    if [ -f "/cdrom/KNOPPIX/boot.img" ]; then  # a syslinux cdrom
       mkdir /mnt/bootimg
       mount -t vfat /cdrom/KNOPPIX/boot.img /mnt/bootimg -o ro,loop
       BOOT="/mnt/bootimg"
    fi   
  ;;   
  "P" | "p")
    if [ -f /etc/sysconfig/toram ]; then
       echo "Stai eseguendo in 'toram'!"
       echo -n "Il programma sta terminando... Premi il tasto invio. "; read gagme
       exit 1
    fi
    SOURCE="/cdrom"
    IMAGE="/cdrom"
    BOOT="/cdrom"
  ;;   
  "I" | "i")
    # read source partition from user                                               
    echo -n "${CYAN}Inserisci il xcorso della iso.  ${WHITE}(ESEMPIO: ${YELLOW}/home/dsl/dsl-0.6.0.iso): ${NORMAL}"
    read SOURCE                                                                     
    if [ -z "$SOURCE" ] ; then                                                      
      echo "Nessuna partizione scelta. Il programma sar terminato."                    
      echo -n "Premi il tasto invio. "; read gagme
      exit 1                                                                        
    fi          
  ;;  
  "W" | "w")
    # read ISO from user
    echo "Assicurati che c sia abbastanza spazio x contenere il file immagine (55MB)!"
    echo -n "${CYAN}Inserisci il nome del file ISO ${WHITE}(ESEMPIO: ${YELLOW}current.iso): ${NORMAL}"
    read ISO
    if [ -z "$ISO" ] ; then
      ISO="current.iso"
    fi
    URL="$PROTOCOL"://"$MIRROR""current"/"$ISO"
    echo "${GRENN}Aspetta che sto scaricando ${MAGENTA}$URL ${NORMAL}"
    wget "$URL"
    if [ $? != 0 ]; then
      rm -f $ISO
      echo "${RED}Scusa l'mmagine ISO non pu essere scaricata o non entra nella partizione"
      echo "Il programma sar terminato...${NORMAL}"
      echo -n "Premi il tasto invio. "; read gagme
      exit 1
    fi
    SOURCE="$ISO"
  ;;  
  "B" | "b")
    if [ -f /etc/sysconfig/toram ]; then
       echo "Stai eseguendo in 'toram'!"
       echo -n "Il programma sar terminato... Premi il tasto invio. "; read gagme
       exit 1
    fi
    mount /dev/fd0 /mnt/auto/floppy
    SOURCE="/cdrom"
    IMAGE="/cdrom"
    BOOT="/mnt/auto/floppy"
  ;;   
esac  


MYDSL=""
echo -n "${CYAN}Inserisci la partizione che conterr le estensioni MyDSL.${WHITE}(ESEMPIO: ${YELLOW}hda3): ${NORMAL}"
read DATA
if [ -z "$DATA" ] ; then
  echo "Nessuna partizione scelta."
  echo "La cartella /tmp sar usata e le estensioni andranno xse dopo il riavvio del sistema"
  echo "A meno che tu non le copi manualmente in una periferica."
else
  MYDSL="mydsl=$DATA"  
fi

DAEMONS=""
echo "${CYAN}parametri d avvio: "
echo -n "${WHITE}Esempio: ${YELLOW}vga=normal toram tz=US/Pacific ssh fuse${NORMAL}: "
read DAEMONS

LANG=""
echo "${CYAN}Scegli la lingua/tastiera se non  quella inglese: "
echo -n "${WHITE}Esempio: ${YELLOW}cs da de es fr nl it pl ru sk${NORMAL}: "
read LANG
if [ ! -z "$LANG" ]; then
   LANG="lang=$LANG"
fi

echo "${YELLOW}Per istallare rispondi y x formattare, x aggiornare rispondi n.${NORMAL} "
echo -n "${RED}Formatto la partizione d destinazione ${MAGENTA}/dev/$TARGET${NORMAL} (y/..)? "
read FORMAT
if [ "$FORMAT" == "y" ]; then
  echo
  echo "${RED}Questa  l'ultima possibilit d uscire prima d distruggere tutti i dati presenti in  ${MAGENTA}/dev/$TARGET${NORMAL}"
  echo -n "${CYAN}Continuo (y/..)?${NORMAL} "
  read answer
  if [ "$answer" != "y" ]; then
    echo "Aborttito.."
    echo -n "Premi il tasto invio. "; read gagme
    exit 0
  fi
  echo
  echo "${BLUE}Sto formattando ${MAGENTA}/dev/$TARGET${NORMAL}"
  mke2fs /dev/$TARGET 
fi
mount /mnt/$TARGET  # Mount the new target drive 

echo "${BLUE}Copio l'immagine del sistema su ${MAGENTA}/mnt/$TARGET${NORMAL}"
if [ "$SOURCE" != "/cdrom" ]; then
  # We need to mount the ISO file using the loopback driver.
  # Start by creating a mount point directory; we'll call it "staging"
  mkdir /mnt/staging
  mount -t iso9660 -o loop,ro $SOURCE /mnt/staging
  if [ $? != 0 ]; then
    umount /mnt/$TARGET  # unmount the target drive 
    echo "${RED}Scusa $SOURCE non trovato!"
    echo "Istallazione fallita!${NORMAL}"
    echo -n "Premi il tasto invio. "; read gagme
    exit 1
  fi  
  IMAGE="/mnt/staging"
  BOOT="/mnt/staging/boot/isolinux"
fi

if [ ! -d /mnt/$TARGET/KNOPPIX ]; then
  mkdir /mnt/$TARGET/KNOPPIX
fi
cp -f $IMAGE/KNOPPIX/KNOPPIX /mnt/$TARGET/KNOPPIX/KNOPPIX
if [ ! -d /mnt/$TARGET/boot ]; then
  mkdir /mnt/$TARGET/boot
fi
cp $BOOT/linux24 /mnt/$TARGET/boot/.
cp $BOOT/minirt24.gz /mnt/$TARGET/boot/.

sync;sync

if [ "$FORMAT" == "y" ]; then
  echo "${BLUE}Istallo grub${NORMAL}"
  mkdir /mnt/$TARGET/boot/grub
  cp /boot/grub/device.map /mnt/$TARGET/boot/grub/. 
  sed 's/hda2/'$TARGET'/' /boot/grub/menu.lst > /mnt/$TARGET/boot/grub/menu.lst
  sed -i "13,28s^frugal^${DAEMONS} ${LANG} ${MYDSL} frugal^" /mnt/$TARGET/boot/grub/menu.lst

  START=`grep -n "Check filesystem" /mnt/$TARGET/boot/grub/menu.lst|cut -f1 -d:`
  if expr "$START" > 0; then
    END=`expr "$START" + 2`
    sed -i "${START},${END}s/^#//" /mnt/$TARGET/boot/grub/menu.lst
  fi

  grub-install /dev/$DISK --root-directory=/mnt/$TARGET
  if [ "$TARGET" != "hda1" ]; then
    echo -n "${CYAN}Hai Windows istallato nella prima partizione ${MAGENTA}/dev/hda1${NORMAL} (y/..)? "
    read answer
    if [ "$answer" == "y" ]; then
      sed -i -e '49,54s/^#//' /mnt/"$TARGET"/boot/grub/menu.lst
    fi
  fi
fi

if [ -n "$DATA" ]; then
  [ -d /mnt/$DATA ] || mkdir /mnt/$DATA
  [ "$DATA" == "$TARGET" ] || mount /dev/$DATA /mnt/$DATA
  [ -d /mnt/$DATA/mydsl ] || mkdir /mnt/$DATA/mydsl
  chown dsl.staff /mnt/$DATA/mydsl
  #touch /mnt/$DATA/"backup.tar.gz"
  umount /mnt/$DATA >/dev/null 2>&1
fi

sync

stringinstring "$INSTALL" "Bb" && umount /mnt/auto/floppy
umount /mnt/$TARGET
echo "${GREEN}Istallazione d grub Completata.${NORMAL}"
echo -n "Premi il tasto invio. "; read gagme
exit 0
