#!/bin/bash
# Based on the work of Terry Gray University of Washington
# This version by Robert Shingledecker

. /etc/init.d/dsl-functions

if [ $UID != 0 ]; then
  echo "6 root?"
  echo -n "Premi il tasto invio. "; read gagme
  exit 1
fi    

MIRROR=$(dslrc.lua Mirror) || MIRROR="ibiblio.org/pub/Linux/distributions/damnsmall/"
PROTOCOL=$(dslrc.lua Protocol) || PROTOCOL="http"

echo
echo "${RED}DSL ${WHITE}Immagine compressa ${BLUE}Istalla/Aggiorna.${NORMAL}"
echo "${YELLOW}Nessuna responsabilit x perdita dati o danneggiamento hardware!${NORMAL}"
echo " "
echo "Una partizione linux larga abbastanza (60MB) dove copiare l'immagine"
echo "deve essere creata prima dell'istallazione."

echo "Una seconda partizione opzionale (ext2 or vfat)"
echo "dove mettere le estensioni MyDSL deve essere creata prima dell'istallazione."

echo "${YELLOW}Questa versione usa Lilo Boot Loader nella partizione specificata."
echo "La partizione deve essere attiva/boot.${NORMAL}"
echo " "
echo "X GRUB, usa frugal_grub.sh"
echo " "
echo -n "${CYAN}Inserisci la partizione che conterr l'immagine d DamnSmallLinux & Lilo ${WHITE}(ESEMPIO: ${YELLOW}hda1): ${NORMAL}" 
read TARGET
if [ -z "$TARGET" ] ; then
  echo "Nessuna partizione scelta. Il programma sar terminato."
  echo -n "Premi il tasto invio. "; read gagme
  exit 1
fi    

DISK="$(echo $TARGET | tr -d [0-9])"

FDISK="$(sfdisk -l /dev/$DISK|grep $TARGET|awk '{print $(NF-1)}'|head -n1)"
if [ "$FDISK" != "83" ]; then
  echo "${RED}Scusa, il sistema non ha rilevato una partizione d tipo linux.${NORMAL}"
  echo "Forse devi solo riavviare il PC, os il sistema pu rileggere"
  echo "la tabella delle partizioni, o crea la(e) tua(e) partizione(i) ${YELLOW}cfdisk"
  echo "${NORMAL}e poi riavvia il computer."
  echo "Il programma sta terminando..."
  echo -n "Premi il tasto invio. "; read gagme
  exit 1
fi

if [ ! -e /mnt/$TARGET ]; then
  mkdir /mnt/$TARGET
fi  

echo "Istalla da:"
echo "  [L]iveCD o istallazione frugale"
echo "  [P]endrive"
echo "  Local [I]so File"
echo "  Sarica l'ultima ISO dal [W]eb"
echo "  Da Poormans via [B]ootfloppy"
echo -n "Scegli (l/p/i/w/b): "
read INSTALL
case "$INSTALL" in 
  "L" | "l")
    if [ -f /etc/sysconfig/toram ]; then
       echo "Stai eseguendo 'toram' mode, not a liveCD!"
       echo -n "Il programma sta terminando... Premi il tasto invio. "; read gagme
       exit 1
    fi
    SOURCE="/cdrom"
    IMAGE="/cdrom"
    BOOT="/cdrom/boot/isolinux"
    if [ -f "/cdrom/KNOPPIX/boot.img" ]; then  # a syslinux cdrom
       mkdir /mnt/bootimg
       mount -t vfat /cdrom/KNOPPIX/boot.img /mnt/bootimg -o ro,loop
       BOOT="/mnt/bootimg"
    fi   
  ;;   
  "P" | "p")
    if [ -f /etc/sysconfig/toram ]; then
       echo "Stai eseguendo 'toram' mode, not a liveCD!"
       echo -n "Il programma sta terminando... Premi il tasto invio. "; read gagme
       exit 1
    fi
    SOURCE="/cdrom"
    IMAGE="/cdrom"
    BOOT="/cdrom"
  ;;   
  "I" | "i")
    # read source partition from user                                               
    echo -n "${CYAN}Inserisci il nome del file ISO ${WHITE}(ESEMPIO: ${YELLOW}current.iso): ${NORMAL}"
    read SOURCE                                                                     
    if [ -z "$SOURCE" ] ; then                                                      
      echo "Nessuna partizione scelta. Il programma sar terminato."                    
      echo -n "Premi il tasto invio. "; read gagme
      exit 1                                                                        
    fi          
  ;;  
  "W" | "w")
    # read ISO from user
    echo "Assicurati che c sia abbastanza spazio x contenere il file immagine (55MB)!"
    echo -n "${CYAN}Inserisci il nome del file ISO ${WHITE}(ESEMPIO: ${YELLOW}current.iso): ${NORMAL}"
    read ISO
    if [ -z "$ISO" ] ; then
      ISO="current.iso"
    fi
    URL="$PROTOCOL"://"$MIRROR""current"/"$ISO"
    echo "${GRENN}Aspetta che sto scaricando ${MAGENTA}$URL ${NORMAL}"
    wget "$URL"
    if [ $? != 0 ]; then
      rm -f $ISO
      echo "${RED}Scusa l'mmagine ISO non pu essere scaricata o non entra nella partizione"
      echo "Il programma sar terminato...${NORMAL}"
      echo -n "Premi il tasto invio. "; read gagme
      exit 1
    fi
    SOURCE="$ISO"
  ;;  
  "B" | "b")
    if [ -f /etc/sysconfig/toram ]; then
       echo "Stai eseguendo in 'toram'!"
       echo -n "Il programma sar terminato... Premi il tasto invio. "; read gagme
       exit 1
    fi
    mount /dev/fd0 /mnt/auto/floppy
    if [ "$?" != 0 ]; then
       echo "Errore montando il floppy."
       exit 1
    fi
    SOURCE="/cdrom"
    IMAGE="/cdrom"
    BOOT="/mnt/auto/floppy"
  ;;   
esac  

echo "${CYAN}parametri d avvio: "
echo -n "${WHITE}Esempio: ${YELLOW}vga=normal toram tz=US/Pacific ssh fuse${NORMAL}: "
read DAEMONS

echo "${CYAN}Scegli la lingua/tastiera se non  quella inglese: "
echo -n "${WHITE}Example: ${YELLOW}cs da de es fr nl it pl ru sk${NORMAL}: "
read LANG
if [ ! -z "$LANG" ]; then
   LANG="lang=$LANG"
fi

RESTORE=""; XVESA=""; MYDSL=""
echo -n "${CYAN}Vuoi specificare una partizione d default x il backup/ripristino ${NORMAL} (y/..)? "
read answer
if [ "$answer" == "y" ]; then
  echo -n "${CYAN}Inserisci la partione che sar usata x il backup/ripristino.${WHITE}(ESEMPIO: ${YELLOW}hda3): ${NORMAL}"
  read DATA
  if [ -z "$DATA" ] ; then
    echo "Nessuna partizione scelta. L'automatico USB/Floppy sar usato."
    RESTORE="restore"
  else
    RESTORE="restore=$DATA"  
  fi
else
  echo -n "${CYAN}Usa le impostazioni d default x Xvesa, ${YELLOW}Xvesa${NORMAL} (y/..)? "
  read answer
  if [ "$answer" == "y" ]; then
    XVESA="xvesa"
  fi
fi
echo -n "${CYAN}Vuoi specificare una partizione diversa x myDSL${NORMAL} (y/..)? "
read answer
if [ "$answer" == "y" ]; then
  echo -n "${CYAN}Inserisci la partizione che sar usata x le estensioni myDSL.${WHITE}(ESEMPIO: ${YELLOW}hda3): ${NORMAL}"
  read DATA
  if [ -z "$DATA" ] ; then
    echo "Nessuna partizione scelt. L'automatico /cdrom sar usato."
  else
    MYDSL="mydsl=$DATA"  
  fi
fi

echo "${YELLOW}X ISTALLARE rispondi y x formattare, x AGGIORNARE ripsondi n.${NORMAL} "
echo -n "${RED}Formatto la partizione ${MAGENTA}/dev/$TARGET${NORMAL} (y/..)? "
read answer
if [ "$answer" == "y" ]; then
  echo
  echo "${RED}Ultima possibilit x uscire prima d distruggere tutti i dati su ${MAGENTA}/dev/$TARGET${NORMAL}"
  echo -n "${CYAN}Continuo (y/..)?${NORMAL} "
  read answer
  if [ "$answer" != "y" ]; then
    echo "Aborted.."
    echo -n "Premi un tasto. "; read gagme
    exit 0
  fi
  echo
  echo "${BLUE}Sto Formattando ${MAGENTA}/dev/$TARGET${NORMAL}"
  mke2fs /dev/$TARGET 
fi
mount /mnt/$TARGET  # Mount the new target drive 

echo "${BLUE}Copio l'immagine del sistema su ${MAGENTA}/mnt/$TARGET${NORMAL}"
if [ "$SOURCE" != "/cdrom" ]; then
  # We need to mount the ISO file using the loopback driver.
  # Start by creating a mount point directory; we'll call it "staging"
  [ -d /mnt/staging ] || mkdir /mnt/staging
  mount -t iso9660 -o loop,ro $SOURCE /mnt/staging
  if [ $? != 0 ]; then
    umount /mnt/$TARGET  # unmount the target drive 
    echo "${RED}Scusa $SOURCE non trovato!"
    echo "Istallazione fallita!${NORMAL}"
    echo -n "Premi un tasto. "; read gagme
    exit 1
  fi  
  IMAGE="/mnt/staging"
  BOOT="/mnt/staging/boot/isolinux"
fi

#cp -af $IMAGE/* /mnt/$TARGET
mkdir /mnt/$TARGET/KNOPPIX
cp -f $IMAGE/KNOPPIX/KNOPPIX /mnt/$TARGET/KNOPPIX/KNOPPIX

# On the target drive we need a place to put the boot files
mkdir /mnt/$TARGET/boot
cp -f $BOOT/linux24 /mnt/$TARGET/boot/.
cp -f $BOOT/minirt24.gz /mnt/$TARGET/boot/.

sync;sync

CMDLINE="$(cat /proc/cmdline)"
POSITION=$(awk '{print index($0, "vga")}' /proc/cmdline)
if [ "$POSITION" == 0 ]; then
  VGA=791
else
  RESULT=$(awk '{print substr($0,index($0, "vga")+3)}' /proc/cmdline)
  VGA=$(getparam 'vga' "$RESULT")
  if [ -z "$VGA" ]; then
    VGA="$(getbootparam 'vga' 2>/dev/null)"
    if [ -z "$VGA" ]; then
       VGA=791
    fi
  fi
fi    

echo "${BLUE}Istallo lilo${NORMAL}"
cat <<EOF >/mnt/$TARGET/boot/lilo.conf
lba32          #enable large disk support
timeout=30     #wait 3 seconds before auto-booting
vga=$VGA
boot=/dev/$TARGET   #put Lilo boot loader in partition of target disk
root=/dev/$TARGET   #set root to be partition of target disk
image=/boot/linux24
label=DSL
initrd=/boot/minirt24.gz
read-only
APPEND="ramdisk_size=100000 init=/etc/init lang=us apm=power-off hda=scsi hdb=scsi hdc=scsi hdd=scsi hde=scsi hdf=scsi hdg=scsi hdh=scsi nomce nodma quiet frugal BOOT_IMAGE=/KNOPPIX/KNOPPIX fromhd=/dev/$TARGET $RESTORE $DAEMONS $LANG $XVESA $MYDSL"
EOF

chmod 644 /mnt/$TARGET/boot/lilo.conf

ln -sf /mnt/$TARGET/boot /

lilo -C /mnt/$TARGET/boot/lilo.conf

stringinstring "$INSTALL" "Bb" && umount /mnt/auto/floppy
umount /mnt/"$TARGET"
echo "${GREEN}Istallazione completata.${NORMAL}"
