#!/bin/bash
#(c) 2007 Robert Shingledecker
#Frugal Grub Pendrive Install

. /etc/init.d/dsl-functions

partition(){
/sbin/sfdisk /dev/sda << EOF
0,$SHARE,b
,,83,*
EOF
/bin/mkdosfs /dev/sda1
/sbin/mke2fs /dev/sda2
hdparm -z /dev/sda
echo "${GREEN}Partizionamento e Format Completati.${NORMAL}"
hdparm -z /dev/sda
sleep 3
}

if [ $UID != 0 ]; then exit 1; fi

if [ -f /etc/sysconfig/toram ]; then
   echo "Non stai usando il LiveCD. Eseguendo in 'toram' non funziona."
   echo -n "Il programma sar terminato. Premi il tatso invio."; read gagme
   exit 1
fi
if [ -f /cdrom/KNOPPIX/boot.img ]; then
   echo -n "Non funziona dal CD SYSLINUX."; read gagme
   exit 1
fi

clear
echo
echo "${RED}DSL ${WHITE}pendrive GRUB boot USB_HDD ${BLUE}istallazione/aggiornamento.${NORMAL}"
echo
echo "1. Il tuo  BIOS deve supportare l'avvio da USB-HDD."
echo "2. 2 partizioni saranno create su ${WHITE}sda,${NORMAL}" 
echo "      la prima ${WHITE}sda1 ${NORMAL}(vfat) , "
echo "      la seconda ${WHITE}sda2 ${NORMAL}(ext2) x il sistema DSL/GRUB."
echo "3. Assicurati che il tuo dispositivo usb sia smontato."
echo
echo "${YELLOW}Nessuna responsibilit in caso d xdita dati o d harware danneggiato!${NORMAL}"
echo

# Check to help the user avoid accidentally installing to the wrong devicename
echo -n "${CYAN}La tua xriferica d massa USB  ${WHITE}sda ? ${YELLOW}(Y/n): ${NORMAL}"
read ANSWER
if [ "$ANSWER" != "n" ] && [ "$ANSWER" != "N" ] ; then
  SEPARATOR="--------------------------------------------------------"
  SEDGREEN="^[\[1;32m"
  SEDNORMAL="^[\[0;39m"
  dmesg | grep -A 4 "SCSI emulation" | sed "s/--/$SEPARATOR/g;/scsi.* disk/ s/disk/disk$SEDGREEN/g;s/ at /$SEDNORMAL at /g"
fi
ANSWER=

TARGET="sda2"
DISK="$(echo $TARGET | tr -d [0-9])"
DATA="$DISK"1

RESULTS="$(hdparm -g /dev/sda|grep geometry|awk '{print $3}')"
CYCLINDERS=`echo $RESULTS | awk -F/ '{print $1}'`
HEADS=`echo $RESULTS | awk -F/ '{print $2}'`
SECTORS=`echo $RESULTS | awk -F/ '{print $3}'|cut -f1 -d,`
UNITS=`expr $HEADS \* $SECTORS \/ 2`
SYSTEM=`expr 1024 \* 52 \/ $UNITS`
SHARE=`expr $CYCLINDERS - $SYSTEM - 1`
#
echo "${CYAN}Lista parametri d avvio: "
echo -n "${WHITE}Esempio: ${YELLOW}vga=normal toram ssh tz=US/Pacific lpd monkey ftp${NORMAL}: "
read DAEMONS

echo "${CYAN}Scegli la lingua/tastiera se non inglese: "
echo -n "${WHITE}Esempio: ${YELLOW}cs da de es fr nl it pl ru sk${NORMAL}: "
read LANG
if [ ! -z "$LANG" ]; then
   LANG="lang=$LANG"
fi

echo -n "${RED}Ultima possibilit.Pronto x procedere.${NORMAL} (y/..)? "
read answer
if [ "$answer" != "y" ]; then
  echo "Abortito dall'utente."
  echo "Premi il tasto invio x continuare: "; read gagme
  exit 1
fi

echo "${GREEN}Cancello l' MBR.${NORMAL}"
dd if=/dev/zero of=/dev/sda bs=512 count=1

echo "${GREEN}Partiziono.${NORMAL}"
partition

if [ ! -e /mnt/$TARGET ]; then
  mkdir /mnt/$TARGET
fi  
mount /dev/$TARGET /mnt/$TARGET  # Mount the new target drive 

echo "${GREEN}Istallo GRUB boot loader.${NORMAL}"
if [ ! -d /mnt/$TARGET/boot/grub ]; then
  mkdir -p /mnt/$TARGET/boot/grub
fi
echo '(hd0) /dev/sda' > /mnt/$TARGET/boot/grub/device.map
grub-install --root-directory=/mnt/$TARGET '(hd0)'

echo "default 0" > /mnt/$TARGET/boot/grub/menu.lst
echo "timeout 10" >> /mnt/$TARGET/boot/grub/menu.lst 
echo "title DSL" >> /mnt/$TARGET/boot/grub/menu.lst
echo "root (hd0,1)" >> /mnt/$TARGET/boot/grub/menu.lst
echo "kernel /linux24 ramdisk_size=100000 lang=us quiet vga=791 frugal " $DAEMONS " " $LANG >> /mnt/$TARGET/boot/grub/menu.lst
echo "initrd /minirt24.gz" >> /mnt/$TARGET/boot/grub/menu.lst

echo "${GREEN}Copio l'immagine d DSL su ${MAGENTA}/mnt/$TARGET${NORMAL}"
SOURCE="/cdrom"
IMAGE="/cdrom"
BOOT="/cdrom/boot/isolinux"
if [ -f "/cdrom/KNOPPIX/boot.img" ]; then  # a syslinux cdrom
   mkdir /mnt/bootimg
   mount -t vfat /cdrom/KNOPPIX/boot.img /mnt/bootimg -o ro,loop
   BOOT="/mnt/bootimg"
fi   

if [ ! -d /mnt/$TARGET/KNOPPIX ]; then
  mkdir /mnt/$TARGET/KNOPPIX
fi
cp -f $IMAGE/KNOPPIX/KNOPPIX /mnt/$TARGET/KNOPPIX/KNOPPIX
sync
cp $BOOT/linux24 /mnt/$TARGET/.
sync
cp $BOOT/minirt24.gz /mnt/$TARGET/.
sync
umount /mnt/$TARGET

if [ ! -e /mnt/$DATA ]; then
  mkdir /mnt/$DATA
fi  
mount /dev/$DATA /mnt/$DATA -t vfat # Mount the data partition

mkdir /mnt/$DATA/mydsl
touch /mnt/$DATA/"backup.tar.gz"
umount /mnt/$DATA

echo "${GREEN}Istallazione Completata.${NORMAL}"
exit 0
