#!/bin/sh

##############################################################
#
# xsetup.sh v0.1.0
CMDLINE="$(cat /proc/cmdline)"
XSERVER="Xvesa Xfbdev"
RESOLUTIONS="640x480 800x600 1024x768 1280x1024 1400x1050 1600x1200"
DEPTHS="4 8 16 24 32"
MOUSE_PORTS="ps2 com1 com2 com3 com4"
BUTTONS="2 3"
 

XSETUP_CONF=$HOME/.xserverrc
DIALOG=/usr/bin/dialog

MENUHEAD="DSL X Setup"

SERVETOP="Xvesa  + veloce e + flessibile.\n
Xfbdev usa frame buffering (deve essere scelto in fase d avvio es. fb1024x768)
   i vecchi portatili tendono a preferire fbdev.\n
Scegliendo annula il default Xvesa 1024x768x32 con
   3 buttoni ps/2 mouse sar usato"

MOUSETOP="ps2  tipico sui nuovi computer.\n
X vecchi computer con mouse seriale:
   COM1 = ttyS0  COM2 = ttyS1 com3 = ttyS2 COM4 = ttyS3\n
X favore scegli la tua porta sotto:"

COLS=68
ROWS=5

TMPFILE=`tempfile -d /tmp -p lingu 2>/dev/null`



OnCancel() 
{ 
	OnDefault "Tu hai cancellato la routine X setup."
}

OnError()
{
	OnDefault "Errore sconosciuto."
}

OnDefault()
{
MOUSE_DEVICE="$(grep MOUSE_DEVICE /etc/sysconfig/knoppix|cut -f2 -d=)"
if [ -z "$MOUSE_DEVICE" ]; then
   MOUSE_DEVICE="/dev/ttyS0"
fi
WHEEL="$(grep Wheel /etc/sysconfig/mouse)"
if [ -n "$WHEEL" ]; then
  MOUSE_DEVICE="$MOUSE_DEVICE,5"
fi
echo "Uso Xvesa default 1024x768x32 -mouse $MOUSE_DEVICE mouse"

XCOMMAND="exec /usr/bin/X11/Xvesa -mouse $MOUSE_DEVICE -screen 1024x768x32 -shadow -nolisten tcp -I &>/dev/null"
echo $XCOMMAND > $XSETUP_CONF
chmod +x $XSETUP_CONF
touch "$HOME"/.XvesaDefault
sudo cp $XSETUP_CONF /etc/skel/. 2>/dev/null
sudo cp "$HOME"/.XvesaDefault /etc/skel/. 2>/dev/null
sleep 1;
exit 1;	
}

CheckReturnVal()
{
   case $? in
      0) ;;
      1) OnCancel;;
      *) OnError;;
   esac
}

ShowMenu()
{
	ITEMS=""
	for i in $3; do
		ITEMS="$ITEMS $i $2";
	done;
	$DIALOG --title "$MENUHEAD" --menu \
		"$1" 20 $COLS $ROWS $ITEMS 2>$TMPFILE
	CheckReturnVal
}

stringinstring(){
case "$2" in *$1*) return 0;; esac
return 1
}

getbootparam(){
stringinstring " $1=" "$CMDLINE" || return 1
result="${CMDLINE##*$1=}"
result="${result%%[ 	]*}"
echo "$result"
return 0
}

getparam(){
stringinstring " $1=" "$2" || return 1
result="${2##*$1=}"
result="${result%%[ 	]*}"
echo "$result"
return 0
}

checkbootparam(){
stringinstring " $1" "$CMDLINE"
return "$?"
}

SetupMouse(){
case "$MPORT" in
  ps2  ) MOUSE_DEVICE="/dev/psaux" ;;
  com1 ) MOUSE_DEVICE="/dev/ttyS0" ;;
  com2 ) MOUSE_DEVICE="/dev/ttyS1" ;;
  com3 ) MOUSE_DEVICE="/dev/ttyS2" ;;
  com4 ) MOUSE_DEVICE="/dev/ttyS3" ;;
esac
return 0
}

VGA="$(getbootparam vga 2>/dev/null)"
if [ "$1" == "default" ]; then
   if [ "$VGA" == 791 ]; then
      OnDefault
      exit
   fi
fi  
ShowMenu "\n$SERVETOP" "xserver" "$XSERVER"
XSERV=`cat $TMPFILE`;

XBUT=""
if $DIALOG --title "$MENUHEAD" --yesno "USB mouse?" 0 0
then
  MOUSE_DEVICE="/dev/input/mice,5"
else
  if $DIALOG --title "$MENUHEAD" --yesno "IMPS/2 mouse wheel?" 0 0
  then
    MOUSE_DEVICE="/dev/psaux,5"
  else
    ShowMenu "\n$MOUSETOP" "port" "$MOUSE_PORTS"
    MPORT=`cat $TMPFILE`
    # Mouse buttons
    ShowMenu "\nChoose number of mouse buttons." "buttons" "$BUTTONS"
    XBUT=`cat $TMPFILE`;
    XBUT="-${XBUT}button";
  fi
fi

SetupMouse
if [ "$XSERV" = "Xfbdev" ]; then
  XCOMMAND="exec /usr/bin/X11/Xfbdev $XBUT -mouse $MOUSE_DEVICE -nolisten tcp -I &>/dev/null"
  echo $XCOMMAND > $XSETUP_CONF
  chmod +x $XSETUP_CONF
  sudo kbdconfig
  exit 0;
else
  ShowMenu "\nScegli la risoluzione dello schermo." "pixel" "$RESOLUTIONS"
  XRES=`cat $TMPFILE`;
  ShowMenu "\nScegli i colori." "bit" "$DEPTHS"
  XDEP=`cat $TMPFILE`
  if $DIALOG --title "$MENUHEAD" --defaultno --yesno "Scegli i dpi? se non hai idea,  meglio saltare questo passo." 8 60
  then
    DPI="-dpi"
    $DIALOG --title "$MENUHEAD" --inputbox "\nscegli i dpi" 0 0 2>$TMPFILE
    XFREQ=`cat $TMPFILE`
  fi
  XCOMMAND="exec /usr/bin/X11/Xvesa $XBUT -mouse $MOUSE_DEVICE -screen $XRES"x"$XDEP $DPI -shadow -nolisten tcp -I &>/dev/null"
fi
echo $XCOMMAND > $XSETUP_CONF
chmod +x $XSETUP_CONF
sudo kbdconfig
exit 0;
