#!/bin/lua
-- (c) 2004-2006 Robert Shingledecker
--
require("fltk")
function updateXserverrc(mode)
   io.input(".xserverrc")
   line = io.read("*line")
   io.input()
   local i,j = string.find(line,"-screen")
   local k,l = string.find(line,"-shadow")
   xserverrc =  string.sub(line,1,j) .. " " .. mode .. " " .. string.sub(line,k)
   io.output(".xserverrc")
   io.write(xserverrc)
   io.flush()
   io.output()
   flag = io.open("/tmp/xvesa","w")
   flag:close()
   os.execute('killall Xvesa')
   return
end

-- Main GUI loop

w = fltk:Fl_Window(150,450, "DSL Xvesa Configurazione")

if os.execute("pidof Xvesa") ~= 0 then
   fltk.fl_message("Impossibile modificare le impostazioni d Xvesa, \nin quanto Xvesa non  in esecuzione!")
   os.exit(1)
end

xvesaModes = os.tmpname()
os.execute("Xvesa -listmodes 2>"..xvesaModes)
local file,err = io.open(xvesaModes,"r")
if not file then
   print("Cannot open file. " .. err)
   os.exit(1)
end
local data = file:read("*a")
file:close()
os.remove(xvesaModes)

i = 1
if string.find(data,"640x480x16") then
   b1 = fltk:Fl_Button(10,10+40*(i-1),130,30, "640X480X16")
   i = i + 1
   b1:callback(function(b1) updateXserverrc(" 640x480x16") end)
end

if string.find(data,"640x480x24") then
   b2 = fltk:Fl_Button(10,10+40*(i-1),130,30, "640X480X24")
   i = i + 1
   b2:callback(function(b2) updateXserverrc(" 640x480x24") end)
end

if string.find(data,"800x600x16") then
   b3 = fltk:Fl_Button(10,10+40*(i-1),130,30, "800x600x16")
   i = i + 1
   b3:callback(function(b3) updateXserverrc(" 800x600x16") end)
end

if string.find(data,"800x600x24") then
   b4 = fltk:Fl_Button(10,10+40*(i-1),130,30, "800x600x24")
   i = i + 1
   b4:callback(function(b4) updateXserverrc(" 800x600x24") end)
end

if string.find(data,"1024x768x16") then
   b5 = fltk:Fl_Button(10,10+40*(i-1),130,30, "1024x768x16")
   i = i + 1
   b5:callback(function(b5) updateXserverrc("1024x768x16") end)
end

if string.find(data,"1024x768x24") then
   b6 = fltk:Fl_Button(10,10+40*(i-1),130,30, "1024x768x24")
   i = i + 1
   b6:callback(function(b6) updateXserverrc("1024x768x24") end)
end

if string.find(data,"1280x1024x16") then
   b7 = fltk:Fl_Button(10,10+40*(i-1),130,30, "1280x1024x16")
   i = i + 1
   b7:callback(function(b7) updateXserverrc("1280x1024x16") end)
end

if string.find(data,"1280x1024x24") then
   b8 = fltk:Fl_Button(10,10+40*(i-1),130,30, "1280x1024x24")
   i = i + 1
   b8:callback(function(b8) updateXserverrc("1280x1024x24") end)
end

if string.find(data,"1400x1050x16") then
   b9 = fltk:Fl_Button(10,10+40*(i-1),130,30, "1400x1050x16")
   i = i + 1
   b9:callback(function(b9) updateXserverrc("1400x1050x16") end)
end

if string.find(data,"1400x1050x24") then
   b10 = fltk:Fl_Button(10,10+40*(i-1),130,30, "1400x1050x24")
   i = i + 1
   b10:callback(function(b10) updateXserverrc("1400x1050x24") end)
end

ok = fltk:Fl_Button(45,10+40*(i-1),70,25,"&OK")
ok:callback(function(ok) os.exit(0) end)

w:show()
Fl:run()
